
#include "SkeletonCalibration.hh"

#include <iostream>
#include <iomanip>
#include <fstream>



/// FILE READER PART

istream &operator>>(istream &stream, station_t &s)
{
	float x,y,z,q[4];
	int t=0,f=0,d,id=-1;
	
	stream >> t >> f >> id >> d >> x >> y >> z >> q[0] >> q[1] >> q[2] >> q[3];
	
	s.head.station = id;
	s.timestamp = t;
	s.framecount = f;
	s.distortion = d;
	s.x = x;
	s.y = y;
	s.z = z;
	for(int i=0; i < 4; i++)
		s.quaternion[i] = q[i];

	return stream;
}

ostream &operator<<(ostream &stream, station_t &s)
{
	int id = s.head.station;
	int t = s.timestamp;
	int f = s.framecount;
	int d = s.distortion;
	float *q = s.quaternion;

	stream << t << " " << f << " " << id << " " << d << " "
	       << s.x << " " << s.y << " " << s.z << " "
	       << q[0] << " " << q[1] << " " << q[2] << " " << q[3] << endl;

	return stream;
}

vector<vector<station_t> >* readFromStream(istream &stream)
{
	station_t s;
	vector<station_t> frame;

	vector<vector<station_t> > *data = new vector<vector<station_t> >;

	stream >> s;
	while(!stream.eof()) {
		unsigned int nFrame = s.framecount;
		while(s.framecount == nFrame && !stream.eof()) {
			frame.push_back(s);
			stream >> s;
		}
		data->push_back(frame);
		frame.clear();
	}

	return data;
}

vector<vector<station_t> >* readFromFile(char *filename)
{
	ifstream file(filename);

	if(!file.is_open()) {
		cerr << "error: could not open file " << filename << endl;
		return 0;
	}

	vector<vector<station_t> > *data = readFromStream(file);
	file.close();
	return data;
}


/// END FILE READER PART

