#include <vector>

#include "protocol.h"

using namespace std;

class SkeletonCalibration;
class GLUquadric;

class SkeletonViewer
{
public:
	SkeletonViewer(SkeletonCalibration *skel);
	~SkeletonViewer();
	void glInit();
	void glDraw();

	void setFrame(vector<station_t> frame);

private:
	void setupLighting();
	void drawCoordinateSystem(float size);
	void drawCylinder(float *from, float *to, float size);
	void drawCube(float size);

	float *errorColor(float e);
	float *errorColor2(float e);

	vector<station_t> currentFrame;
	SkeletonCalibration *skeleton;

	float errorRange;
	
	GLUquadric* _quad;
	float _color[3];
};
