#include "SkeletonCalibration.hh"
#include "SkeletonEnv.hh"

#include <iostream>
#include <fstream>

int main(int argc, char *argv[])
{
	if(argc < 3) {
		cerr << "syntax: cal-skeleton logfile resultfile [first_sample last sample]" << endl;
		return 0;
	}

	vector<vector<station_t> > *data = readFromFile(argv[1]);
	vector<vector<station_t> > data_cropped;

	int n = (*data)[data->size() / 2].size(); // inspect a frame in the middle

	cerr << "found " << data->size() << " frames with " << n << " sensors" << endl;

	SkeletonCalibration skel(n,25000);

	if(argc >= 5) {
		int first = atol(argv[3]);
		int last = atol(argv[4]);

		data_cropped.assign(((first < 0) ? data->end() : data->begin())+first,
		                    ((last  < 0) ? data->end() : data->begin())+last);
	} else {
		data_cropped.assign(data->begin(), data->end());
	}

	skel.addData(&data_cropped);
	skel.guessRoot();
	skel.calibrateSkeleton();

	ofstream file(argv[2]);
	skel.writeCalibrationResult(file);
	file.close();

	delete data;
}
